/*
 * Copyright (c) 2014 project TAMOP-4.2.2.C-11/1/KONV-2012-0013
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
		
package lehurament.AggregateObservers;

import peersim.config.*;
import peersim.core.*;
import lehurament.CommonForGAPs.*;
/**
*/
public class SendTimePacket implements Control {


//--------------------------------------------------------------------------
//Parameters
//--------------------------------------------------------------------------

/**
 * The protocol to operate on.
 * @config
 */
private static final String PAR_PROT = "protocol";
private static final String PAR_STEP = "step";
private static final String PAR_CYCLES = "cycles";
//--------------------------------------------------------------------------
// Fields
//--------------------------------------------------------------------------

/** The name of this observer in the configuration */
private final String name;


/** Protocol identifier */
private final int pid;
private final int step;
private final int cycles;

//--------------------------------------------------------------------------
// Constructor
//--------------------------------------------------------------------------

/**
 * Standard constructor that reads the configuration parameters.
 * Invoked by the simulation engine.
 * @param name the configuration prefix for this class
 */
public SendTimePacket(String name)
{
	this.name = name;
	pid = Configuration.getPid(name + "." + PAR_PROT);
	step = Configuration.getInt(name + "." + PAR_STEP);
	cycles = Configuration.getInt(name + "." + PAR_CYCLES);
}

//--------------------------------------------------------------------------
// Methods
//--------------------------------------------------------------------------
/**
 */
public boolean execute()
{
	for (int i = 0; i < Network.size(); i++) 
	{
		Node node = Network.get(i);
		GAPVariablesHolder prot = (GAPVariablesHolder) node.getProtocol(pid);
		GAPPacket p=new GAPPacket();
		p.type=p.type.TIMEOUT;
		prot.sendPacketToNode(node,node,pid,p);
	}
return (false);
}

}


