/*
 * Copyright (c) 2003-2005 The BISON Project
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package lehurament.peersim.dynamics;

import peersim.core.*;
import peersim.config.*;
import peersim.dynamics.*;

/**
 * This {@link Control} can change the size of networks by adding and removing
 * nodes. Can be used to model churn. This class supports only permanent removal
 * of nodes and the addition of brand new nodes. That is, temporary downtime
 * is not supported by this class.
 */
public class DynamicNetworkExt extends DynamicNetwork implements Control
{
	
public DynamicNetworkExt(String prefix)
{
super(prefix);
}

protected void remove(int n)
{
	int nodeID;
	for (int i = 0; i < n; ++i) {
		do {
			nodeID = CommonState.r.nextInt(Network.size());
		}
		while (nodeID==0);
//        System.out.println("KIVEVE: "+nodeID+" "+Network.get(nodeID).getID());
		Network.remove(nodeID);
	}
	
}
}
